<?php

function normalizeRow($oneRow) {
    // Loại bỏ khoảng trắng dư thừa ở đầu và cuối chuỗi
    $oneRow = trim($oneRow);
    
    // Loại bỏ dấu ngoặc kép nếu có
    $oneRow = str_replace("\"", "", $oneRow);

    // Kiểm tra nếu chuỗi chứa tab ("\t") thì tách theo tab, nếu không thì tách theo dấu phẩy
    if (strpos($oneRow, "\t") !== false) {
        $oneRow = explode("\t", $oneRow); // Tách theo tab
    } else {
        $oneRow = explode(",", $oneRow);  // Tách theo dấu phẩy
    }
    // Đảm bảo mảng có đúng 5 phần tử
    while (count($oneRow) < 5) {
        $oneRow[] = "#"; // Hoặc "" nếu muốn thêm xâu rỗng
    }
    return $oneRow;
}

function flattenArray($array) {
    $flattened = [];
    array_walk_recursive($array, function($value) use (&$flattened) {
        $flattened[] = $value;
    });
    return $flattened;
}

function fnCheckUserRegistered(){
    $uPhone=$_COOKIE["uPhone"];
    $uname =$_COOKIE["uname"];
    $uEmail =@$_COOKIE["uEmail"];
    $User_registered=0;
    $User_registered_list=["0988086099-tuananhktmt@gmail.com"];
    $myfile = fopen("Users/User_registered.txt", "r") or die("Unable to open file!");
    
    while(!feof($myfile)) {
      $User_registered_list[]=strtolower(trim(fgets($myfile)));
    }
    fclose($myfile);
    
    $muser=strtolower("{$uPhone}-{$uEmail}");
    
    if(in_array($muser,$User_registered_list)) $User_registered=1;
    return $User_registered;    
}
function FnSaveDataLocation($result, $mName,$fn='location.csv')
{
    global $cookie_uniqID_vl, $no_access_vl;
    // Ghi lại tất cả các thông tin sau khi tính toán
    $mfolder = "data/";
    if (!file_exists($mfolder)) {
        mkdir($mfolder, 0777);
    }
    $filename = $mfolder . $fn;
    if (!file_exists($filename)) {
        $out = fopen($filename, "w");
        fprintf($out, chr(0xef) . chr(0xbb) . chr(0xbf));
        fputcsv($out, array_merge(["Timestamp"],$mName, ["cookie_uniqID_vl","no_access_vl"])); 
        fclose($out);
    }
    $out = fopen($filename, "a");
    fprintf($out, date("Y/m/d-H:i:s") . ",");
    $merged_array = array_merge($result, [$cookie_uniqID_vl, $no_access_vl]);
    $flattened_array = flattenArray($merged_array);
    fputcsv($out, $flattened_array);

    fclose($out);
}


function FnSaveData($result, $mName,$level)
{
    global $cookie_uniqID_vl, $no_access_vl;
    // Ghi lại tất cả các thông tin sau khi tính toán
    $mfolder = "data/";
    if (!file_exists($mfolder)) {
        mkdir($mfolder, 0777);
    }
     
    $result=array_merge([$level],$result);
    $filename = $mfolder . "danhsach_".$level.".csv";
    if (!file_exists($filename)) {
        $out = fopen($filename, "w");
        fprintf($out, chr(0xef) . chr(0xbb) . chr(0xbf));
        fputcsv($out, array_merge(["Timestamp","Levels"],$mName, ["cookie_uniqID_vl","no_access_vl"])); 
        fclose($out);
    }
    $out = fopen($filename, "a");
    fprintf($out, date("Y/m/d-H:i:s") . ",");
    $merged_array = array_merge($result, [$cookie_uniqID_vl, $no_access_vl]);
    $flattened_array = flattenArray($merged_array);

    fputcsv($out, $flattened_array);
    fclose($out);
}

function FnSaveDataUserPost($arr2save,$fn)
{
    $uPhone=@$_COOKIE["uPhone"];
    $uname =@$_COOKIE["uname"];
    $uEmail =@$_COOKIE["uEmail"];

    $mfolder = "data/";
    if (!file_exists($mfolder)) {
        mkdir($mfolder, 0777);
    } 
    
    $filename = $fn;
    if (!file_exists($filename)) {
        $out = fopen($filename, "w");
        fprintf($out, chr(0xef) . chr(0xbb) . chr(0xbf));
        fputcsv($out, array_merge(["Timestamp","Họ tên:{$uname}","Ngày sinh","Phone:{$uPhone}","Notes:{$uEmail}"])); 
        fclose($out);
    }
    $KhongTonTai=true;
    $handle = fopen($fn, 'r');
        while (($data = fgetcsv($handle)) !== FALSE) {
            // if($data[]){
            //     $KhongTonTai=false;
            // }
            if( $data[1]===$arr2save[0] &&
                $data[2]===$arr2save[1] &&
                $data[3]===$arr2save[2] &&
                $data[4]===$arr2save[3]){$KhongTonTai=false;}
            // print_r($data);
    }
    if($KhongTonTai){        
        $out = fopen($filename, "a");
        fputcsv($out, array_merge([date("Y/m/d-H:i:s")],$arr2save));
        fclose($out);
    }
}
// Functions list:------------------------------------------
function vn_str_filter($str)
{
    $unicode = [
        "a" => "á|à|ả|ã|ạ|ă|ắ|ặ|ằ|ẳ|ẵ|â|ấ|ầ|ẩ|ẫ|ậ",
        "d" => "đ",
        "e" => "é|è|ẻ|ẽ|ẹ|ê|ế|ề|ể|ễ|ệ",
        "i" => "í|ì|ỉ|ĩ|ị",
        "o" => "ó|ò|ỏ|õ|ọ|ô|ố|ồ|ổ|ỗ|ộ|ơ|ớ|ờ|ở|ỡ|ợ",
        "u" => "ú|ù|ủ|ũ|ụ|ư|ứ|ừ|ử|ữ|ự",
        "y" => "ý|ỳ|ỷ|ỹ|ỵ",
        "A" => "Á|À|Ả|Ã|Ạ|Ă|Ắ|Ặ|Ằ|Ẳ|Ẵ|Â|Ấ|Ầ|Ẩ|Ẫ|Ậ",
        "D" => "Đ",
        "E" => "É|È|Ẻ|Ẽ|Ẹ|Ê|Ế|Ề|Ể|Ễ|Ệ",
        "I" => "Í|Ì|Ỉ|Ĩ|Ị",
        "O" => "Ó|Ò|Ỏ|Õ|Ọ|Ô|Ố|Ồ|Ổ|Ỗ|Ộ|Ơ|Ớ|Ờ|Ở|Ỡ|Ợ",
        "U" => "Ú|Ù|Ủ|Ũ|Ụ|Ư|Ứ|Ừ|Ử|Ữ|Ự",
        "Y" => "Ý|Ỳ|Ỷ|Ỹ|Ỵ",
    ];
    foreach ($unicode as $nonUnicode => $uni) {
        $str = preg_replace("/($uni)/i", $nonUnicode, $str);
    }
    return $str;
}
$data = [
    "0" => 0,
    "1" => 1,
    "2" => 2,
    "3" => 3,
    "4" => 4,
    "5" => 5,
    "6" => 6,
    "7" => 7,
    "8" => 8,
    "9" => 9,    
    "A" => 1,
    "B" => 2,
    "C" => 3,
    "D" => 4,
    "E" => 5,
    "F" => 6,
    "G" => 7,
    "H" => 8,
    "I" => 9,
    "J" => 1,
    "K" => 2,
    "L" => 3,
    "M" => 4,
    "N" => 5,
    "O" => 6,
    "P" => 7,
    "Q" => 8,
    "R" => 9,
    "S" => 1,
    "T" => 2,
    "U" => 3,
    "V" => 4,
    "W" => 5,
    "X" => 6,
    "Y" => 7,
    "Z" => 8,
    " " => " ",
];
$TenNguyenAm = [
    "A" => 1,
    "U" => 3,
    "E" => 5,
    "W" => 5,
    "O" => 6,
    "I" => 9,
    "Y" => 7,
    "_" => " ",
    " " => " ",
];
$TenPhuAm = [
    "J" => 1,
    "S" => 1,
    "K" => 2,
    "B" => 2,
    "T" => 2,
    "C" => 3,
    "L" => 3,
    "M" => 4,
    "D" => 4,
    "V" => 4,
    "N" => 5,
    "W" => 5,
    "F" => 6,
    "X" => 6,
    "P" => 7,
    "G" => 7,
    "Y" => 7,
    "Q" => 8,
    "H" => 8,
    "Z" => 9,
    "R" => 9,
    "_" => " ",
    " " => " ",
];
// End Functions list:------------------------------------------
function GetNumberFromString($ns, $SoDacbiet=array(11,22,33),$Label='...')
{
    // SUM, str: số tổng, string diễn giải
    /*  input:
    ns: ngày sinh, dạng ngày/tháng/năm: dd/mm/yyyy
    output:
    $ns : Tổng cuối cùng của các số trong ns
    $str: xâu chứa các phép tính diễn giải:
    VD:  0+2+1+1+1+9+8+1=23<br>2+3=5
    */
    // echo $Label;
    // var_dump($Label);
    // var_dump($SoDacbiet);
    // die();
    $str = "$ns=";
    $NumB = 0;
    $Nmax = 9;
    $digits = (int) preg_replace("/[^0-9.]+/", "", $ns); 
    if ((!in_array($digits, $SoDacbiet)) && $digits > $Nmax) {
        // if ($Label=="Nstr") echo ' '.$digits.'=>';
        while ((!in_array($digits, $SoDacbiet)) && $digits > $Nmax) {  
            $digits = "" . $digits;
            $NumB = 0;
            for ($k = 0; $k < strlen($digits); $k++) {
                $NumB += (int) $digits[$k];
                $str .= $digits[$k] . "+";                                        // 0+2+1+1+1+9+8+1=23<br>2+3=5
            }
            
            $str = substr($str, 0, strlen($str) - 1) . "=" . $NumB . "<br>";
            $digits = (int) $NumB; //5
            
            // if ($Label=="Nstr"){var_dump($NumB);var_dump($str);var_dump(in_array($digits, $SoDacbiet)); echo "--------------\n";}
        }
    } else {
        $str = "" . $ns . "<br>";
        $NumB = (int) $ns;
    }
    $str = substr($str, 0, strlen($str) - 4); 
    return [$NumB, $str];
}

// $NumB, $str, $TimSo2ChuSo
function GetNumberFromString_expand($ns, $SoDacbiet=array(11,22,33),$Label='...', $includeThese=array(13,14,16,19))
{
    // SUM, str: số tổng, string diễn giải
    /*  input:
    ns: ngày sinh, dạng ngày/tháng/năm: dd/mm/yyyy
    output:
    $ns : Tổng cuối cùng của các số trong ns
    $str: xâu chứa các phép tính diễn giải:
    VD:  0+2+1+1+1+9+8+1=23<br>2+3=5
    */
    // echo $Label;
    // var_dump($Label);
    // var_dump($SoDacbiet);
    // die();
    $str = "$ns=";
    $NumB = 0;
    $Nmax = 9;
    $TimSo2ChuSo=[];
    $digits = (int) preg_replace("/[^0-9.]+/", "", $ns); 
    if ((!in_array($digits, $SoDacbiet)) && $digits > $Nmax) {
        // if ($Label=="Nstr") echo ' '.$digits.'=>';
        while ((!in_array($digits, $SoDacbiet)) && $digits > $Nmax) {  
            if (in_array($digits, $includeThese) ){
                array_push($TimSo2ChuSo, $digits);  
            }
            $digits = "" . $digits;
            $NumB = 0;
            for ($k = 0; $k < strlen($digits); $k++) {
                $NumB += (int) $digits[$k];
                $str .= $digits[$k] . "+";                                        // 0+2+1+1+1+9+8+1=23<br>2+3=5
            }
            
            $str = substr($str, 0, strlen($str) - 1) . "=" . $NumB . "<br>";
            $digits = (int) $NumB; //5
            
            // if ($Label=="Nstr"){var_dump($NumB);var_dump($str);var_dump(in_array($digits, $SoDacbiet)); echo "--------------\n";}
        }
    } else {
        $str = "" . $ns . "<br>";
        $NumB = (int) $ns;
    }
    $str = substr($str, 0, strlen($str) - 4); 
    return [$NumB, $str, $TimSo2ChuSo];
}

function GetNumberFromString_Cach2($Ngaysinh, $Thangsinh, $Namsinh)
{
    /*
    output:
    $num : Tổng cuối cùng của các số trong ns
    $str: xâu chứa các phép tính diễn giải:
    VD:  0+2+1+1+1+9+8+1=23<br>2+3=5
    */
    $str ="<b>Cách tính (cộng dọc) </b><br> Ngày tháng năm sinh=" .$Ngaysinh ."/" .$Thangsinh ."/" .$Namsinh ."<br>";
    // $digits = (int)preg_replace('/[^0-9.]+/', '', $Ngaysinh.$Thangsinh.$Namsinh);
    $v1 = GetNumberFromString($Ngaysinh,$SoDacbiet=[11,22,33],$Label='v1');
    $v2 = GetNumberFromString($Thangsinh,$SoDacbiet=[11,22,33],$Label='v2');
    $v3 = GetNumberFromString($Namsinh,$SoDacbiet=[11,22,33],$Label='v3');

    $num = $v1[0] + $v2[0] + $v3[0];
    $str .= "Ngày:" . $v1[1] . "<br>Tháng:" . $v2[1] . "<br>Năm:" . str_replace("<br>", "=>", $v3[1]) . "<br>";
    $v4 = GetNumberFromString($num,$SoDacbiet=[11,22,33],$Label='v4');

    $num = $v4[0];
    $str .= $v1[0] . "+" . $v2[0] . "+" . $v3[0] . "====<b>" . $num . "</b>";
    return [$num, $str];
}
function getNameBasic($NameVal, $data, $sothieu = false)
    {
        /* input:
         *      NameVal: name in string
         * output:
         *      $tenstr:  Tên dạng xâu ký tự
         *      $tenNum:  Tên dạng số
         *      $Nstr[0]: Số tổng các số
         *      $Nstr[1:  Xâu diễn giải +
         */
        $tenstr = vn_str_filter($NameVal);
        $tenstr = preg_replace("/[^0-9a-zA-Z ]+/", "", $tenstr);
        $tenstr = strtoupper($tenstr);
        // var_dump($tenstr);
        $ten = "";
        for ($k = 0; $k < strlen($tenstr); $k++) {
            $ten .= $data[$tenstr[$k]];
        }
        $tenNum = $ten;
        $Nstr = GetNumberFromString($ten,$SoDacbiet=[],$Label='Nstr');
        if ($sothieu) {
            $fullSo = "123456789";
            $soInput = explode("=", $ten)[0];
            // echo $soInput."<br>";
            for ($k = 0; $k < 10; $k++) {
                // echo $k.":".strpos($soInput, "".$k)."<br>";
                if (strpos($soInput, "" . $k) !== false) {
                    $fullSo = str_replace($k, "", $fullSo);
                }
            }
            return [$fullSo];
        }
        return [$tenstr, $tenNum, $Nstr[0], $Nstr[1]];
    }
function fnConvertCharString2Numstring($strVal,$data){
        $tenstr = vn_str_filter($strVal);
        $tenstr = preg_replace("/[^0-9a-zA-Z]+/", "", $tenstr);
        $tenstr = strtoupper($tenstr);
        $ten = "";
        for ($k = 0; $k < strlen($tenstr); $k++) {
            $ten .= $data[$tenstr[$k]];
        }
        return $ten;
    }
function fnSum_number_Fullname_vertical($fullname,$data){
        $tenstr = vn_str_filter($fullname);
        $tenstr = strtoupper($tenstr);
        $tenstr = preg_replace("/[^0-9a-zA-Z ]+/", "", $tenstr);        
        $arHoTen=explode(" ", $tenstr);
        $SumStr=array();
        foreach($arHoTen as $word){
            $NumTen = "";
            for ($k = 0; $k < strlen($word); $k++) {
                $NumTen .= $data[$word[$k]];
            }
            $Nstr = GetNumberFromString($NumTen,$SoDacbiet=[11,22,33],$Label='Nstr');
            array_push($SumStr,[$word, $NumTen,$Nstr[0], $Nstr[1]]) ;
        }
        // var_dump($SumStr);
            // array(3) {
            //       [0]=>  array(4) {
            //         [0]=>    string(6) "NGUYEN"
            //         [1]=>    string(6) "573755"
            //         [2]=>    int(5)
            //         [3]=>    string(30) "573755=5+7+3+7+5+5=32<br>3+2=5"
            //       }
            //       [1]=>  array(4) {
            //         [0]=>    string(4) "TUAN"
            //         [1]=>    string(4) "2315"
            //         [2]=>    int(11)
            //         [3]=>    string(15) "2315=2+3+1+5=11"
            //       }
            //       [2]=>  array(4) {
            //         [0]=>    string(3) "ANH"
            //         [1]=>    string(3) "158"
            //         [2]=>    int(5)
            //         [3]=>    string(21) "158=1+5+8=14<br>1+4=5"
            //       }
            //     }
        $tenNum_detail='';
        $tenInt=0;
        $tenStrSum='';
        $tenIntstr='';
        foreach($SumStr as $aW){
            $tenNum_detail.=$aW[1]." ";
            $tenInt+=$aW[2];
            $tenIntstr.=$aW[2].'+';
            $tenStrSum.=$aW[0].': '.str_replace ('<br>','=>',$aW[3]).'<br/>';
        }
        $tenIntstr = substr($tenIntstr, 0, strlen($tenIntstr) - 1) . "=" . $tenInt . "<br>";
        // var_dump($tenstr);
        // var_dump($tenNum_detail);
        // var_dump($tenInt);
        // var_dump($tenIntstr);
        // var_dump($tenStrSum);
        $tensumFinal = GetNumberFromString($tenInt,$SoDacbiet=[],$Label='tensumFinal');
        // var_dump($tensumFinal);
        $tenStrSum.=$tenIntstr.'===>'.$tensumFinal[1];
        $ret=[$tenstr, $tenNum_detail, $tensumFinal[0], $tenStrSum];
        // return ([0,0,0,0]);
        // var_dump($ret);
        // die();
        return $ret;
}
// $fullname="Nguyễn Tuấn Anh";
// $KQ2_5=fnSum_number_Fullname_vertical($fullname,$data);
// echo $KQ2_5[0].'<br>';
// echo $KQ2_5[1].'<br>';
// echo $KQ2_5[2].'<br>';
// echo $KQ2_5[3].'<br>';

// // var_dump($KQ2_5);

// die();

function fnSum_number_Fullname_vertical_expand($fullname,$data, $includeThese=array(13,14,16,19)){
        $tenstr = vn_str_filter($fullname);
        $tenstr = strtoupper($tenstr);
        $tenstr = preg_replace("/[^0-9a-zA-Z ]+/", "", $tenstr);        
        $arHoTen=explode(" ", $tenstr);
        $SumStr=array();
        foreach($arHoTen as $word){
            $NumTen = "";
            for ($k = 0; $k < strlen($word); $k++) {
                $NumTen .= $data[$word[$k]];
            }
            $Nstr = GetNumberFromString($NumTen,$SoDacbiet=[11,22,33],$Label='Nstr');
            array_push($SumStr,[$word, $NumTen,$Nstr[0], $Nstr[1]]) ;
        } 
        $tenNum_detail='';
        $tenInt=0;
        $tenStrSum='';
        $tenIntstr='';
        foreach($SumStr as $aW){
            $tenNum_detail.=$aW[1]." ";
            $tenInt+=$aW[2];
            $tenIntstr.=$aW[2].'+';
            $tenStrSum.=$aW[0].': '.str_replace ('<br>','=>',$aW[3]).'<br/>';
        }
        $tenIntstr = substr($tenIntstr, 0, strlen($tenIntstr) - 1) . "=" . $tenInt . "<br>"; 
        $tensumFinal = GetNumberFromString_expand($tenInt,$SoDacbiet=[],$Label='tensumFinal',$includeThese=$includeThese);
        // var_dump($tensumFinal);
        $tenStrSum.=$tenIntstr.'===>'.$tensumFinal[1];
        $ret=[$tenstr, $tenNum_detail, $tensumFinal[0], $tenStrSum]; 
        $csBaiHoc=$tensumFinal[2];
        return [$ret,$csBaiHoc];
}



function getNguyenAm_PhuAm($NameVal, $data, $TenPhuAm, $TenNguyenAm, $NA_PA)
{
    $hoten = vn_str_filter(trim($NameVal));
    $hoten = strtoupper($hoten);
    // Xét nguyên âm, phụ âm sẽ tính dựa vào nguyên âm
    $nguyenAm = "";
    $Phu___Am = "";
    // Y đứng cạnh nguyên âm thì nó là phụ âm, còn lại là nguyên âm
    for ($i = 0; $i < strlen($hoten); $i++) {
        $ch = $hoten[$i];
        // var_dump($ch);
        // var_dump (array_key_exists($ch, $TenNguyenAm));
        if ($ch == " ") {
            $nguyenAm .= " ";
            $Phu___Am .= " ";
            continue;
        }
        if ($ch == "Y") {
            $PA = 0;
            for ($k = 0; $k < strlen($hoten); $k++) {
                if (($hoten[$k]!=" ") && array_key_exists($hoten[$k], $TenNguyenAm) && ($k == $i - 1 || $k == $i + 1) ) {
                    $PA++;
                }
            }
            if ($PA > 0) {
                //Phụ âm
                $Phu___Am .= "Y";
                $nguyenAm .= "_";
            } else {
                //nguyên âm
                $Phu___Am .= "_";
                $nguyenAm .= "Y";
            }
        } else {
            // Nếu là chữ bthuong:
            if (array_key_exists($ch, $TenNguyenAm)) {
                $Phu___Am .= "_";
                $nguyenAm .= $ch;
            } else {
                $Phu___Am .= $ch;
                $nguyenAm .= "_";
            }
        }
    }
    // var_dump($Phu___Am);
    // var_dump($nguyenAm);
    $ten = "";
    $ten_so = "";

    if ($NA_PA == "nguyenAm") {
        for ($k = 0; $k < strlen($nguyenAm); $k++) {
            if ($TenNguyenAm[$nguyenAm[$k]] != " ") {
                $ten .= $TenNguyenAm[$nguyenAm[$k]];
                $ten_so .= $TenNguyenAm[$nguyenAm[$k]];
            } else {
                $ten_so .= $nguyenAm[$k];
            }
        }
        // var_dump("Ho ten:Nguyen Am:gtri: $hoten:$nguyenAm:$ten");
        $KQ = GetNumberFromString($ten_so,$SoDacbiet=[],$Label='nguyenAm');
        // var_dump($KQ);
        //     $("#KhatTam").html("Con số Linh hồn/khát tâm/tâm hồn: <font face = \"Courier New\" > "+nsten+"<br>"+hoten+"=><br>"+nguyenAm+'<br>'+ten_so+"<br>"+str1+"</font>");
        //     $("#KhatTam-"+nsten).show();
        return [$nguyenAm, $KQ[0], $KQ[1]];
    } else {
        for ($k = 0; $k < strlen($Phu___Am); $k++) {
            if ($TenPhuAm[$Phu___Am[$k]] != " ") {
                $ten .= $TenPhuAm[$Phu___Am[$k]];
                $ten_so .= $TenPhuAm[$Phu___Am[$k]];
            } else {
                $ten_so .= $Phu___Am[$k];
            }
        }
        // var_dump("Ho ten:Phu    Am:gtri: $hoten:$Phu___Am:$ten");
        $KQ = GetNumberFromString($ten_so,$SoDacbiet=[],$Label='Phu___Am');
        //       $("#NhanCach").html("Con số nhân cách: <font face = \"Courier New\"> "+nsten+"<br>"+hoten+"=><br>"+Phu___Am+'<br>'+ten_so+"<br>"+str1+"</font>");
        //       $("#nhanCach-"+nsten).show();
        return [$Phu___Am, $KQ[0], $KQ[1]];
    }
}

function getNguyenAm_PhuAm_expand($NameVal, $data, $TenPhuAm, $TenNguyenAm, $NA_PA, $includeThese=array(13,14,16,19))
{
    $hoten = vn_str_filter(trim($NameVal));
    $hoten = strtoupper($hoten);
    // Xét nguyên âm, phụ âm sẽ tính dựa vào nguyên âm
    $nguyenAm = "";
    $Phu___Am = "";
    // Y đứng cạnh nguyên âm thì nó là phụ âm, còn lại là nguyên âm
    for ($i = 0; $i < strlen($hoten); $i++) {
        $ch = $hoten[$i];
        // var_dump($ch);
        // var_dump (array_key_exists($ch, $TenNguyenAm));
        if ($ch == " ") {
            $nguyenAm .= " ";
            $Phu___Am .= " ";
            continue;
        }
        if ($ch == "Y") {
            $PA = 0;
            for ($k = 0; $k < strlen($hoten); $k++) {
                if (($hoten[$k]!=" ") && array_key_exists($hoten[$k], $TenNguyenAm) && ($k == $i - 1 || $k == $i + 1) ) {
                    $PA++;
                }
            }
            if ($PA > 0) {
                //Phụ âm
                $Phu___Am .= "Y";
                $nguyenAm .= "_";
            } else {
                //nguyên âm
                $Phu___Am .= "_";
                $nguyenAm .= "Y";
            }
        } else {
            // Nếu là chữ bthuong:
            if (array_key_exists($ch, $TenNguyenAm)) {
                $Phu___Am .= "_";
                $nguyenAm .= $ch;
            } else {
                $Phu___Am .= $ch;
                $nguyenAm .= "_";
            }
        }
    }
    // var_dump($Phu___Am);
    // var_dump($nguyenAm);
    $ten = "";
    $ten_so = "";

    if ($NA_PA == "nguyenAm") {
        for ($k = 0; $k < strlen($nguyenAm); $k++) {
            if ($TenNguyenAm[$nguyenAm[$k]] != " ") {
                $ten .= $TenNguyenAm[$nguyenAm[$k]];
                $ten_so .= $TenNguyenAm[$nguyenAm[$k]];
            } else {
                $ten_so .= $nguyenAm[$k];
            }
        }
        // var_dump("Ho ten:Nguyen Am:gtri: $hoten:$nguyenAm:$ten");
        $KQ = GetNumberFromString_expand($ten_so,$SoDacbiet=[],$Label='nguyenAm',$includeThese=$includeThese);
        // var_dump($KQ);
        //     $("#KhatTam").html("Con số Linh hồn/khát tâm/tâm hồn: <font face = \"Courier New\" > "+nsten+"<br>"+hoten+"=><br>"+nguyenAm+'<br>'+ten_so+"<br>"+str1+"</font>");
        //     $("#KhatTam-"+nsten).show();
        return [$nguyenAm, $KQ[0], $KQ[1],$KQ[2]];
    } else {
        for ($k = 0; $k < strlen($Phu___Am); $k++) {
            if ($TenPhuAm[$Phu___Am[$k]] != " ") {
                $ten .= $TenPhuAm[$Phu___Am[$k]];
                $ten_so .= $TenPhuAm[$Phu___Am[$k]];
            } else {
                $ten_so .= $Phu___Am[$k];
            }
        }
        // var_dump("Ho ten:Phu    Am:gtri: $hoten:$Phu___Am:$ten");
        $KQ = GetNumberFromString_expand($ten_so,$SoDacbiet=[],$Label='Phu___Am',$includeThese=$includeThese);
        //       $("#NhanCach").html("Con số nhân cách: <font face = \"Courier New\"> "+nsten+"<br>"+hoten+"=><br>"+Phu___Am+'<br>'+ten_so+"<br>"+str1+"</font>");
        //       $("#nhanCach-"+nsten).show();
        return [$Phu___Am, $KQ[0], $KQ[1], $KQ[2]];
    }
}
function csv_to_array($file_name) {
        $data =  $header = array();
        $i = 0;
        if (file_exists("test.txt")){
            echo "Xin lỗi, hệ thống đã hết tiền vận hành!"; die();
        }
        $file = fopen($file_name, 'r');
        while (($line = fgetcsv($file)) !== FALSE) {
            $line=array_map('trim', $line);
            if( $i==0 ) {
                $header = $line;
            } else {
                $data[] = $line;        
            }
            $i++;
        }
        $_data=[];
        fclose($file);
        foreach ($data as $key => $_value) {
            $new_item = array();
            foreach ($_value as $key => $value) {
                $new_item[ $header[$key] ] =$value;
            }
            $_data[] = $new_item;
        }
        return $_data;
    }
function csv_to_array_v2($file_name) {
        // echo $file_name."===============================\n";
        $data =  $header = array();
        $i = 0;
        $file = fopen($file_name, 'r');
        // while ( ($line = fgetcsv($file)) !== FALSE) {
        while (($line = fgets($file)) !== false) {

            $line = preg_replace('!\s+!', ' ', $line);
            $line0= str_replace('#','',$line); 
            $line0= str_replace("~~",'',$line0); 
            $line0=trim($line0);
            // echo("\n\nLine0: ");
            // var_dump($line0);
            if (strlen($line0)==0) continue;
            
            $line=explode('#', $line);
            $line=array_map('trim', $line);
            if( $i==0 ) {
                $header = $line;
            } else {
                $data[] = $line;        
            }
            $i++;
        }
        // var_dump($data);
        // echo "\n\n\n";

        $_data=[];
        fclose($file); 

        foreach ($data as $key => $_value) {
            $new_item = array(); 
                for($k=0; $k<count($header); $k++){
                    // foreach ($_value as $key => $value) { 
                    // echo "Key: $key value=$value\n";
                    $new_item[ $header[$k] ] = $_value[$k]; 
                }
                // echo "\n\n";
                $_data[] = $new_item; 
        }
        // echo $file_name."--------------------------------------\n\n\n";        
        return $_data;
    }

// --------------------------------------------------------------
 function csv_to_array_v3($filename) {
    $rows = array();
    
    if (file_exists($filename)) {
        $file = fopen($filename, 'r');
        
        // Bỏ qua dòng tiêu đề
        $header = fgetcsv($file);
        
        // Đọc từng dòng và chuyển đổi thành mảng
        while (($data = fgetcsv($file)) !== FALSE) {
            if (count($data) == 3) {
                $key = intval($data[0]);
                $rows[$key] = array($header[1] => intval($data[1]), $header[2] => intval($data[2]));
            }
        }
        
        fclose($file);
    } else {
        echo "File not found: " . $filename;
    }
    // var_dump($rows);
    return $rows;
}

// // Sử dụng hàm để đọc các tệp TXT
// $toado = csv_to_array("imgs/v6.txt");
// $btnSize = csv_to_array("imgs/v6_size.txt");

// // Hiển thị các giá trị như yêu cầu
// for ($k = 0; $k < count($toado); $k++) {
//     if (isset($toado[$k]) && isset($btnSize[$k])) {
//         echo "#btn" . $k . "{position:absolute;left:" .
//              ($toado[$k]['x']) . "px;top :" .
//              ($toado[$k]['y'] + 20) . "px;" .
//              "width: " . $btnSize[$k]['x'] . "px;" .
//              "height: " . $btnSize[$k]['y'] . "px;}\n";
//     }
// }
// --------------------------------------------------------------

$PhanTach_user="\n###========================================================###\n";
$PhanTach_data="---###---\n";
function Kienthuc_Read_File($file_name,$thisPerson_Phone){
    global $PhanTach_user,$PhanTach_data;
    // đọc file text, tách user => tách mục => trả về kết quả array.
    $file_name=$file_name;
    // var_dump($file_name);
    $DAT="";
    if (file_exists($file_name))
        $DAT=file_get_contents($file_name);
    
    $DATarr_user=explode($PhanTach_user,$DAT);
    // var_dump($DATarr_user);
    $DAT_final=array();
    $thePerson=[];
    foreach ($DATarr_user as $oneUser){
        if(strlen(trim($oneUser))==0) continue;
        // echo $oneUser."\n";
        $dat1=explode($PhanTach_data,$oneUser); 
        if (strpos($dat1[0], $thisPerson_Phone) !== false ) {
                $thePerson=$dat1;
        }else{
            $DAT_final[]=$dat1;           
        }
    }
    // var_dump($DAT_final);
    if($file_name=="KienThuc/Info_().txt"){ 
        $DAT_final=[["Thông tin bảo mật, khi không chọn xanh ô nào, thì đây là thông tin cá nhân từng người","",""]];
    }
    return [$DAT_final,$thePerson];
}
function Kienthuc_Join_array2string($DAT_final){
    global $PhanTach_user,$PhanTach_data;
    $DATarr_user=array();
    foreach ($DAT_final as $oneUser){ 
        $DATarr_user[]=implode($PhanTach_data, $oneUser);
    }
    $DAT=implode($PhanTach_user, $DATarr_user);
    // var_dump($DAT);
    return $DAT;
}
function Kienthuc_Combine($user1,$phone1,$email1,$liked1,$content1,$DAT_final){
    foreach ($DAT_final as $key=>$oneUser){ 
        if (strpos($oneUser[0], $phone1) !== false ){
            if($liked1 != -1) $DAT_final[$key][1]=$liked1;
            if($content1 != -1) $DAT_final[$key][2]=$content1;
            return $DAT_final;
        }
    }
    $DAT_final[]=array("{$user1}-{$phone1}-{$email1}",$liked1,$content1);
    return $DAT_final;
}

function Kienthuc_Write_File($file_name,$user1, $phone1, $email1, $liked1, $content1){
    global $PhanTach_user,$PhanTach_data;
    // post nội dung của 1 user lên => ghép vào thành chuẩn:
    // tên user-sđt-email 
    // Like
    // content
    //
    // Đọc file đã có, tìm user đó => thay thế nội dung => ghi vào file. 
    if(! file_exists("KienThuc")){
        mkdir('KienThuc', 0777, true);
    }
    $DAT_final=Kienthuc_Read_File($file_name,$phone1)[0];
    $DAT_final=Kienthuc_Combine($user1,$phone1,$email1,$liked1,$content1,$DAT_final);
    $DAT_final=Kienthuc_Join_array2string($DAT_final);
    file_put_contents($file_name,$DAT_final);
}

// Kienthuc_Write_File("KienThuc/{$fn}");
// $DAT_final=Kienthuc_Read_File($fn);
// var_dump($DAT_final);
// echo "=========================88888888==================================\n";
// $DAT=Kienthuc_Join_array2string($DAT_final);
// var_dump($DAT);

// ===== Ghi vao file: ==========================================================
// $userPostContent=<<<xxx
// 33333content content content content content 1234444444444
// content content content 4444444
// content content content content content4444444444444 content\n
// xxx; 


//  $file_name= "KienThuc/abc.txt";
// //  $user1= "tên user343434";
//  $phone1= "sđt6";
// //  $email1= "email4";
// //  $liked1= 3333;
// //  $content1=$userPostContent;
// // Kienthuc_Write_File($file_name,$user1, $phone1, $email1, $liked1, $content1);

// $Dat=Kienthuc_Read_File($file_name= $file_name,$thisPerson_Phone= $phone1);
// // var_dump($Dat);
// echo json_encode($Dat);
?>