<?php
// Kết nối tới cơ sở dữ liệu SQLite
try {
    $db = new SQLite3('myClass.db');
    echo "Kết nối tới cơ sở dữ liệu thành công.\n";

    // Mảng chứa các cột cần thêm
    $columns = [
        'uname TEXT',
        'uPhone TEXT',
        'uEmail TEXT',
        'LastModified DATETIME DEFAULT CURRENT_TIMESTAMP',
        'Notes TEXT',
        'myCol TEXT'
    ];

    // Lấy thông tin bảng courses
    $result = $db->query("PRAGMA table_info(courses)");
    $existingColumns = [];
    while ($row = $result->fetchArray(SQLITE3_ASSOC)) {
        $existingColumns[] = $row['name']; // Lấy tên cột
    }

    // Thêm từng cột nếu chưa tồn tại
    foreach ($columns as $column) {
        $columnName = explode(' ', $column)[0]; // Lấy tên cột từ định nghĩa
        if (!in_array($columnName, $existingColumns)) {
            $db->exec("ALTER TABLE courses ADD COLUMN $column");
            echo "Đã thêm cột $columnName vào bảng.\n";
        } else {
            echo "Cột $columnName đã tồn tại trong bảng.\n";
        }
    }

    echo "Hoàn thành việc thêm cột.\n";
} catch (Exception $e) {
    echo "Lỗi: " . $e->getMessage() . "\n";
}
