<?php
$Home_Path = "/apps/Classes"; // nút home return về.
$title = "Web - System";
date_default_timezone_set("Asia/Ho_Chi_Minh");
if (isset($_POST["Logout"])) {
    setcookie("uname", 0, time() - 3600, "/"); //
    setcookie("uPhone", 0, time() - 3600, "/"); //
    setcookie("uEmail", 0, time() - 3600, "/");
    header("Refresh:0");
};

if (!isset($_COOKIE["uPhone"]) or !isset($_COOKIE["uname"]) or !isset($_COOKIE["uEmail"])) {
    if (file_exists("login.php")) {
        header("location:login.php");
    } else {
        header("location:../login.php");
    }
    exit(); // Đảm bảo dừng thực thi sau khi chuyển hướng
}

// Error handling for database connection
try {
    $db = new SQLite3('myClass.db');
    $db->enableExceptions(true); // Enable exceptions for better error tracking

    // Use a prepared statement for better security
    $stmt = $db->prepare("SELECT * FROM courses ORDER BY CreatedDate DESC;");
    $courses = $stmt->execute();
} catch (Exception $e) {
    // Handle database connection or query errors
    header('location:admin.php');
    die("Database error: " . $e->getMessage());
}

require_once "taFunc.php"
?>

<!DOCTYPE html>
<html lang="vi">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Học trực tuyến</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.7.1/css/all.min.css" rel="stylesheet">

    <link href="learning.css" rel="stylesheet">
    <style>

    </style>
</head>

<body>

    <div class="container mt-4">
        <div class="row">
            <!-- Nav Categories -->
            <div class="col-md-8">
                <ul class="nav nav-pills">
                    <?php
                    $uname = @$_COOKIE["uname"];
                    $uPhone = @$_COOKIE["uPhone"];
                    $uEmail = @$_COOKIE["uEmail"];
                    $allowedEmails = ['tuananhktmt@gmail.com', 'tuananhvxl@gmail.com', 'nt.anh.fai@gmail.com'];
                    // if ($uPhone === "0988086099" && in_array($uEmail, $allowedEmails)) {
                    //     // Hiển thị nút khi điều kiện đúng
                    //     echo '<li class="nav-item"><a class="nav-link" onclick="location.href=\'admin.php\'">Go to Admin</a></li>';
                    // } else {
                    //     // Hiển thị thông báo khi điều kiện sai
                    //     echo '<li class="nav-item"> Xin chào $uName! </li>';
                    // }
                    ?>



                    <li class="nav-item"> <a class="nav-link " href="index.php"><i class="fa-solid fa-rotate"></i></a> </li>
                    <li class="nav-item"> <a class="nav-link taFilter active" href="#" data-category="all"><i class="fa-solid fa-layer-group"></i></a> </li>
                    <?php
                    $categories = $db->query("SELECT DISTINCT category FROM courses");
                    while ($category = $categories->fetchArray(SQLITE3_ASSOC)): ?>
                        <li class="nav-item">
                            <a class="nav-link taFilter" href="#" data-category="<?php echo htmlspecialchars($category['category']); ?>">
                                <?php echo htmlspecialchars($category['category']); ?>
                            </a>
                        </li>
                    <?php endwhile; ?>
                </ul>
            </div>
            <!-- Search Bar -->
            <div class="col-md-2">
                <input type="text" id="searchInput" class="form-control" placeholder="Tìm kiếm...">
            </div>
            <div class="col-md-2">
                <a class="btn btn-outline-primary" href="<?php echo $Home_Path; ?>"><i class="fa-solid fa-house"></i></a>
                <!-- <a class="btn btn-outline-warning" href="/tsh/logout.php"><i class="fa fa-sign-out" aria-hidden="true"></i></a> -->
                <form action="" method="post" style="display: inline;">
                    <button type="submit" name="Logout" value="Logout" class="btn btn-outline-warning"><i class="fa fa-sign-out" aria-hidden="true"></i></button>
                </form>

                <a class="btn btn-outline-info mx-2" onclick="location.href='admin.php'"><?php
                                                                                            $array = explode(" ", $uname);
                                                                                            $lastname = array_pop($array);
                                                                                            echo $lastname;
                                                                                            ?> <i class="fa-solid fa-gear"></i></a>

            </div>

        </div>
    </div>



    <?php
    // Kiểm tra nếu có `id` trong GET
    if (isset($_GET['id'])) {
        $vidid = intval($_GET['id']);
        // Gọi hàm hiển thị video với `vidid`
        echo "<script>document.addEventListener('DOMContentLoaded', function() { displayVideoById($vidid); });</script>";
    }
    ?>
    <div class="container taContainer mt-4">
        <h1><?php echo $title; ?></h1>
        <div class="video-container mt-3" id="videoContainer">
            <!-- Video YouTube sẽ hiển thị ở đây -->
        </div>
        <div class="row" id="coursesContainer">
            <?php while ($course = $courses->fetchArray(SQLITE3_ASSOC)): ?>
                <div class="col-md-3 ta_card mb-4 mt-3">
                    <div class="card course-card" id="<?php echo $course['id']; ?>"
                        data-vidid="<?php echo $course['id']; ?>"
                        data-video="<?php $videoEmbed = processVideoLink($course['video_link']);
                                    echo $videoEmbed; ?>"
                        data-info="<?php
                                    $html = sprintf(
                                        '<div><h3>[%d] %s</h3>
                            <div class="row">
                                <div class="row">
                                <div class="col-6"><b>Category:</b> %s</div>
                                <div class="col-6"><b>Lecturer:</b> %s</div>
                                </div><div class="row">
                                <div class="col-6 mt-2"  ><b>Visits:</b> <span id="visit%d">%d</span></div>
                                <div class="col-6 mt-2">
                                    <button type="button" class="btn btn-outline-primary position-relative"  onclick=taFnLike("%d", event)>
                                        <i class="fas fa-thumbs-up"></i>
                                        <span class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger" id="btnLike%d">
                                            %d
                                            <span class="visually-hidden">Like</span>
                                        </span>
                                    </button>
                                 
                                </div>
                            </div> </div>
                            <p><b>Description:</b> %s</p>
                            <p><a href="?id=%d">Open this video link</a> </p>
                            </div><hr/>',
                                        intval($course['id']),
                                        htmlspecialchars($course['title']),
                                        htmlspecialchars($course['category']),
                                        htmlspecialchars($course['lecturer']),
                                        intval($course['id']), //visit%d
                                        intval($course['visits']), //%d</span></div>
                                        intval($course['id']), //"%d", event
                                        intval($course['id']), //btnLike%d
                                        intval($course['poll']), //%d
                                        htmlspecialchars($course['description']),
                                        intval($course['id']),

                                    );
                                    echo htmlspecialchars($html);
                                    ?>">
                        <img class="ta_Image_Card"
                            src="images/<?php echo htmlspecialchars(file_exists('images/' . $course['image']) ? $course['image'] : 'default-image.jpg'); ?>"
                            class="card-img-top"
                            alt="Image">

                        <div class="card-body">
                            <h5 class="card-title"><?php echo '[' . $course['id'] . '] ' . htmlspecialchars($course['title']); ?></h5>
                            <div class="row card-text">
                                <div class="row">
                                    <div class="col-6"><b>Loại:</b> <?php echo htmlspecialchars($course['category']); ?></div>
                                    <div class="col-6"><b>GV:</b> <?php echo htmlspecialchars($course['lecturer']); ?></div>
                                </div>
                                <div class="row">
                                    <div class="col-6"><b>Xem:</b> <?php echo htmlspecialchars($course['visits']); ?></div>
                                    <div class="col-6">
                                        <button
                                            type="button"
                                            class="btn btn-outline-primary position-relative btn-sm"
                                            onclick="event.stopPropagation(); taFnLike(<?php echo intval($course['id']); ?>, event)">
                                            <i class="fas fa-thumbs-up"></i>&nbsp;&nbsp;&nbsp;&nbsp;
                                            <span class="position-absolute top-50 start-100 translate-middle badge rounded-pill bg-danger" id="LikeCover<?php echo intval($course['id']); ?>">
                                                <?php echo htmlspecialchars($course['poll']); ?>
                                                <span class="visually-hidden">Like</span>
                                            </span>
                                        </button>

                                    </div>
                                </div>
                            </div>
                            <p class="card-text"><?php echo htmlspecialchars($course['description']); ?></p>
                        </div>
                    </div>
                </div>
            <?php endwhile; ?>
        </div>
    </div>

    <div class="container">
        <button class="theme-toggle" onclick="toggleTheme()">
            <i class="fa-solid fa-circle-half-stroke"></i>
        </button>

    </div>

    <hr />
    <div class='container'>
        <iframe src="puplic_message.php" frameborder="0" style="width:100%; height:570px; overflow-x: hidden;"></iframe>
    </div>
    <hr />


    <div class='container'>
        <style type="text/css">
            .message {
                margin-bottom: 10px;
                padding: 10px;
                border-radius: 5px;
                background-color: #eaeaea;
                /* Nền màu xám sáng */
                color: #0a1658;
                /* Chữ màu tối */
                font-family: Arial, sans-serif;
            }

            .message strong {
                color: #5a3c29;
                font-weight: bold;
                /* Màu nâu sẫm cho tên người dùng */
            }

            .btn-clear {
                background-color: #5e5127;
                color: #fff;
            }
        </style>
        <div class="container mt-4">

            <H4>Private Messages</H4>

            <div class="row">
                <div class="col-8">
                    <!-- Form control -->
                    <div class="mb-3">
                        <input type="text" class="form-control" id="messageInput" placeholder="Type your message">
                    </div>
                </div>
                <div class="col-4">
                    <!-- Button group -->
                    <div class="btn-group" role="group" aria-label="Message options">
                        <button type="button" class="btn btn-primary" onclick="sendMessage()"><i class="fa-regular fa-floppy-disk"></i></button>
                        <button type="button" class="btn btn-outline-warning" onclick="clearMessages()"><i class="fa-solid fa-trash"></i></button>
                    </div>
                </div>
                <!-- Chat container -->
            </div>
            <div id="chatContainer" class="mt-3"></div>

            <script type="text/javascript">
                // Hàm lấy giá trị cookie theo tên
                function getCookie(name) {
                    let cookieValue = document.cookie.match('(^|;)\\s*' + name + '=([^;]+)');
                    return cookieValue ? cookieValue.pop() : '';
                }

                // Nếu cookie 'uName' không tồn tại, tạo một ID mới
                if (!getCookie('uname')) {
                    let randomID = 'user_' + Math.random().toString(36).substring(2, 15);
                    document.cookie = 'uname=' + randomID + '; path=/';
                }

                // Gán màu sắc ngẫu nhiên cho từng uname
                const colorMap = {};

                function getColorForUser(userName) {
                    if (!colorMap[userName]) {
                        colorMap[userName] = '#' + Math.floor(Math.random() * 16777215).toString(16);
                    }
                    return colorMap[userName];
                }

                // Hiển thị các tin nhắn từ localStorage
                function loadMessages() {
                    const savedMessages = JSON.parse(localStorage.getItem('chatMessages')) || [];
                    const chatContainer = document.getElementById('chatContainer');
                    chatContainer.innerHTML = ''; // Xóa nội dung cũ
                    savedMessages.forEach((msg) => {
                        const messageDiv = document.createElement('div');
                        messageDiv.classList.add('message');
                        messageDiv.style.color = getColorForUser(msg.userName);
                        messageDiv.innerHTML = `<strong>${msg.userName}:</strong> ${msg.text}`;
                        chatContainer.appendChild(messageDiv);
                    });
                }

                // Lưu tin nhắn vào localStorage
                function saveMessage(userName, text) {
                    const savedMessages = JSON.parse(localStorage.getItem('chatMessages')) || [];
                    savedMessages.push({
                        userName,
                        text
                    });
                    localStorage.setItem('chatMessages', JSON.stringify(savedMessages));
                }

                // Hàm gửi tin nhắn
                function sendMessage() {
                    const userName = getCookie('uname');
                    const message = document.getElementById('messageInput').value;
                    if (message.trim() !== '') {
                        // Hiển thị tin nhắn trên giao diện
                        const chatContainer = document.getElementById('chatContainer');
                        const messageDiv = document.createElement('div');
                        messageDiv.classList.add('message');
                        messageDiv.style.color = getColorForUser(userName);
                        messageDiv.innerHTML = `<strong>${userName}:</strong> ${message}`;
                        chatContainer.appendChild(messageDiv);

                        // Lưu vào localStorage
                        saveMessage(userName, message);

                        // Xóa nội dung input sau khi gửi
                        document.getElementById('messageInput').value = '';
                    }
                }

                // Hàm xóa toàn bộ tin nhắn
                function clearMessages() {
                    localStorage.removeItem('chatMessages'); // Xóa tin nhắn trong localStorage
                    document.getElementById('chatContainer').innerHTML = ''; // Xóa hiển thị trên giao diện
                }

                // Tải tin nhắn khi trang được tải
                window.onload = loadMessages;
            </script>
        </div>
    </div>



    <script>
        // Hàm hiển thị video dựa trên ID
        function displayVideoById(vidid) {
            const card = document.querySelector(`.course-card[data-vidid="${vidid}"]`);
            if (!card) {
                console.warn("Không tìm thấy video với ID:", vidid);
                return;
            }
            const videoLink = card.getAttribute('data-video');
            const videoInfo = card.getAttribute('data-info');
            taFnView(vidid);
            // Hiển thị video và thông tin
            document.getElementById('videoContainer').innerHTML = ` ${videoLink} <div class="mt-3">${videoInfo}</div> `;
            window.scrollTo(0, 0);
        }

        // Sự kiện click vào khóa học
        document.addEventListener('click', function(event) {
            if (event.target.closest('.course-card')) {
                const card = event.target.closest('.course-card');
                const vidid = card.getAttribute('data-vidid');
                const videoLink = card.getAttribute('data-video');
                if (videoLink.includes('youtu')) { // Kiểm tra xem videoLink có chứa 'youtu' hay không
                    displayVideoById(vidid); // Gọi hàm hiển thị video
                } else {
                    taFnView(vidid);
                    window.location.href = videoLink; // Điều hướng đến liên kết video
                }
            }
        });


        function taFnLike(id, event) {
            // Ngăn hành động mặc định của nút
            if (event) event.preventDefault();

            // Gửi yêu cầu AJAX
            fetch('like_poll.php', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                    },
                    body: new URLSearchParams({
                        course_id: id
                    })
                })
                .then(response => response.json())
                .then(data => {
                    if (data.success) {
                        // Tìm nút like liên quan và cập nhật số lượng like
                        // const button = document.querySelector(`button[onclick='taFnLike("${id}", event)']`);
                        // const badge = button.querySelector('.badge');
                        const badge = document.getElementById("LikeCover" + id);
                        badge.textContent = data.poll; // Cập nhật giá trị mới
                    } else {
                        console.log('Unable to like this course. Please try again.');
                    }
                })
                .catch(err => {
                    console.error('Error:', err);
                    console.log('An error occurred. Please try again later.');
                });
        }


        function taFnView(id) {
            // Gửi yêu cầu AJAX
            fetch('ViewClass.php', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                    },
                    body: new URLSearchParams({
                        course_id: id
                    })
                })
                .then(response => response.json())
                .then(data => {
                    if (data.success) {
                        const visitid = document.getElementById('visit' + id);
                        visitid.textContent = data.visits; // Cập nhật giá trị mới

                        // Tìm nút like liên quan và cập nhật số lượng like
                        // const button = document.querySelector(`button[onclick='taFnLike("${id}")']`);
                        // const badge = button.querySelector('.badge');
                        // badge.textContent = data.visits; // Cập nhật giá trị mới
                    } else {
                        console.log('Unable to view this course. Please try again.');
                    }
                })
                .catch(err => {
                    console.error('Error:', err);
                    console.log('An error occurred. Please try again later.');
                });
        }
    </script>
    <script>
        // Function to toggle the theme
        // Áp dụng lớp dark-theme khi chuyển đổi
        function toggleTheme() {
            document.body.classList.toggle('dark-theme');
            // Lưu trạng thái vào localStorage
            if (document.body.classList.contains('dark-theme')) {
                localStorage.setItem('theme', 'dark');
            } else {
                localStorage.setItem('theme', 'light');
            }
        }

        // Tự động áp dụng theme từ localStorage khi tải trang
        if (localStorage.getItem('theme') === 'dark') {
            document.body.classList.add('dark-theme');
        }


        $(document).ready(function() {
            // Lọc theo category
            $('.taFilter').on('click', function(e) {
                e.preventDefault();
                const category = $(this).data('category').toString();

                // Đặt class 'active' cho link đã chọn
                $('.taFilter').removeClass('active');
                $(this).addClass('active');

                // Hiển thị hoặc ẩn các thẻ course dựa trên category
                $('.course-card').each(function() {
                    const courseCategory = $(this).find('.card-text .col-6:first').text().trim().replace('Loại: ', '');
                    if (category === 'all' || courseCategory === category) {
                        $(this).parent().show();
                    } else {
                        $(this).parent().hide();
                    }
                });
            });

            // Tìm kiếm theo từ khóa
            $('#searchInput').on('keyup', function() {
                const keyword = $(this).val().toLowerCase();

                // Lọc dựa trên tiêu đề hoặc mô tả
                $('.course-card').each(function() {
                    const title = $(this).find('.card-title').text().toLowerCase();
                    const description = $(this).find('.card-text:last').text().toLowerCase();

                    if (title.includes(keyword) || description.includes(keyword)) {
                        $(this).parent().show();
                    } else {
                        $(this).parent().hide();
                    }
                });
            });
        });
    </script>




    <br />
    <br />
    <br />
    <br />
    <br />
    <br />
</body>

</html>