<?php
date_default_timezone_set("Asia/Ho_Chi_Minh");
define('DB_PATH', 'usage_log.db');
?>
<!-- device_management.php -->
<!DOCTYPE html>
<html lang="vi">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=0.8">
    <title>Quản lý thiết bị</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
    <link href="https://cdn.jsdelivr.net/gh/gitbrent/bootstrap4-toggle@3.6.1/css/bootstrap4-toggle.min.css" rel="stylesheet">
    <script src="https://cdn.jsdelivr.net/gh/gitbrent/bootstrap4-toggle@3.6.1/js/bootstrap4-toggle.min.js"></script>
</head>
<body>
<div class="container-fluid p-2">
    <h2>Quản lý Người Dùng - Users Manager</h2>
    <table class="table table-striped">
        <thead>
        <tr>
            <th>Phê duyệt</th>
            <th>id*</th>            
            <th>Name</th>
            <th>BirthDate</th>
            <th>uPhone</th>
            <th>uEmail</th>
            <th>device_id</th>
            <th>approved</th>
            <th>access</th>
            <th>CreatedDate</th>
            <th>last_access</th>
            <th>UserData</th>
            <th>Note</th>            
            <th>Xóa</th>            
        </tr>
        </thead>
        <tbody id="deviceList">
        <?php
        $db = new SQLite3(DB_PATH);
        // $result = $db->query("SELECT * FROM user_logs ORDER BY uPhone, uEmail");
        $result = $db->query("SELECT * FROM user_logs ORDER BY id DESC");
        while ($row = $result->fetchArray(SQLITE3_ASSOC)) {
            $approved=$row['approved'] ? "checked" : "";
            echo <<<xxx
                    <tr>   
                    
                    <td>
                        <input type='checkbox'  data-toggle="toggle" data-onstyle="primary" class='approveDevice' data-id='{$row['id']}' {$approved}>
                    </td>                 
                    <td>{$row['id']}</td>                    
                    <td>{$row['Name']}</td>
                    <td>{$row['BirthDate']}</td>
                    <td>{$row['uPhone']}</td>
                    <td>{$row['uEmail']}</td>
                    <td>{$row['device_id']}</td>
                    <td>{$row['approved']}</td>
                    <td>{$row['count']}</td>
                    <td>{$row['CreatedDate']}</td>
                    <td>{$row['last_access']}</td>
                    <td>{$row['UserData']}</td>
                    <td>{$row['Note']}</td>
                    <td>                         
                        <button class='btn btn-danger delete_user' data-id='{$row['id']}' data-name='{$row['Name']}' data-uphone='{$row['uPhone']}' data-uemail='{$row['uEmail']}'> Xóa </button>   
                    </td> 
                </tr>
                xxx;
        }
        ?>
        </tbody>
    </table>
</div>
<script>
    $(document).ready(function() {
        $('.approveDevice').on('change', function() {
            var id = $(this).data('id');
            var approved = $(this).is(':checked') ? 1 : 0;
            $.ajax({
                url: 'approve_device.php',
                method: 'POST',
                data: {
                    id: id,
                    approved: approved
                },
                success: function(response) {
                    alert('Thiết bị đã được cập nhật');
                    // location.reload();
                }
            });
        });

       $('.delete_user').on('click', function() {
            var id = $(this).data('id');
            var name = $(this).data('name');
            var uPhone = $(this).data('uphone');
            var uEmail = $(this).data('uemail');
            var res = confirm(`Bạn có chắc chắn muốn xóa thành viên này không?:\n${id}: ${name}, ${uPhone} - ${uEmail}?`);
            if (res) {
                console.log('Delete: id='+id);
                $.ajax({
                    url: 'delete_user.php',
                    method: 'POST',
                    data: {
                        id: id
                    },
                    success: function(response) {
                        alert('Đã xóa thành viên thành công');
                        // Bạn có thể thêm mã để làm mới bảng hoặc cập nhật giao diện người dùng sau khi xóa
                        location.reload(); // Tải lại trang để cập nhật danh sách người dùng
                    }
                });
            }
        });
        

    });

</script>
</body>
</html>
