<?php
$courses_dir = __DIR__ . '/courses'; // Thư mục gốc của các khóa học
$base_url = '/apps/Classes/courses'; // Đường dẫn root URL

$groups = [];
if (is_dir($courses_dir)) {
    // Quét các thư mục cấp 1 (nhóm khóa học)
    $group_dirs = array_filter(glob("$courses_dir/*"), 'is_dir');
    foreach ($group_dirs as $group) {
        $group_name = basename($group); // Lấy tên nhóm khóa học
        // Quét các thư mục cấp 2 (khóa học)
        $course_dirs = array_filter(glob("$group/*"), 'is_dir');
        $courses = [];
        foreach ($course_dirs as $course) {
            $course_name = basename($course);
            $course_url = $base_url . '/' . urlencode($group_name) . '/' . urlencode($course_name) . '/index.php'; // URL đến file index.php
            $courses[] = ['name' => $course_name, 'url' => $course_url];
        }
        $groups[] = ['name' => $group_name, 'courses' => $courses];
    }
}

// Trả về HTML
foreach ($groups as $group): ?>
    <div class="course-group">
        <h3><i class="fas fa-layer-group"></i> <?php echo htmlspecialchars($group['name']); ?></h3>
        <ul class="list-unstyled">
            
            <?php
            $cnt = 0;
            foreach ($group['courses'] as $course):
                $cnt = $cnt+1;
                ?>
                <li>
                    <a href="<?php echo htmlspecialchars($course['url']); ?>" class="btn btn-outline-info course-item" target="_blank">
                        <i class="fas fa-book"></i>  <?php echo $cnt.'. '. htmlspecialchars($course['name']); ?>
                    </a>
                </li>
            <?php endforeach; ?>
        </ul>
    </div>
<?php endforeach; ?>
