<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Courses</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.1/css/all.min.css" rel="stylesheet">
    <style>
        body {
            background-color: #f8f9fa;
            color: #343a40;
        }

        .course-group {
            background-color: #ffffff;
            border: 1px solid #ddd;
            border-radius: 5px;
            padding: 15px;
            margin-bottom: 20px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
        }

        .course-item {
            color: #007bff;
        }

        .course-item:hover {
            text-decoration: none;
        }

        .loader {
            display: none;
            text-align: center;
            margin-top: 20px;
        }
    </style>
</head>

<body>
    <div class="container py-5">
        <h1 class="text-center mb-4"><i class="fas fa-graduation-cap"></i> Explore Our Courses</h1>
        <div id="course-list">
            <!-- Course list will be loaded here -->
        </div>
        <div class="loader" id="loader">
            <i class="fas fa-spinner fa-spin fa-3x"></i>
        </div>
    </div>
    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js"></script>
    <script>
        $(document).ready(function() {
            $('#loader').show();
            $.ajax({
                url: 'get_courses.php',
                method: 'GET',
                success: function(response) {
                    $('#course-list').html(response);
                },
                error: function() {
                    alert('Failed to load courses.');
                },
                complete: function() {
                    $('#loader').hide();
                }
            });
        });
    </script>
</body>

</html>