<?php
// Kết nối CSDL
$db = new SQLite3('public_notes.db');

// Lấy tin nhắn
$query = 'SELECT m.id, m.text, m.timestamp, u.username, u.color 
          FROM messages m 
          JOIN users u ON m.user_id = u.id 
          ORDER BY m.timestamp DESC';

$results = $db->query($query);
?>
<!DOCTYPE html>
<html>

<head>
    <title>Tin Nhắn</title>
    <meta charset="UTF-8">
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 10px;
            background-color: #f4f4f4;
        }

        .message-list {
            list-style-type: none;
            padding: 0;
        }

        .message {
            background-color: white;
            margin-bottom: 10px;
            padding: 10px;
            border-radius: 5px;
            box-shadow: 0 1px 3px rgba(0, 0, 0, 0.1);
        }

        .message-header {
            display: flex;
            justify-content: space-between;
            margin-bottom: 5px;
        }

        .message-username {
            font-weight: bold;
        }

        .message-time {
            color: #888;
            font-size: 0.8em;
        }

        .message-text {
            color: #333;
        }
    </style>
</head>

<body>
    <ul class="message-list">
        <?php while ($row = $results->fetchArray(SQLITE3_ASSOC)): ?>
            <li class="message">
                <div class="message-header">
                    <span class="message-username" style="color:<?php echo htmlspecialchars($row['color']); ?>">
                        <?php echo htmlspecialchars($row['username']); ?>
                    </span>
                    <span class="message-time">
                        <?php echo date('H:i d/m/Y', strtotime($row['timestamp'])); ?>
                    </span>
                </div>
                <div class="message-text">
                    <?php echo htmlspecialchars($row['text']); ?>
                </div>
            </li>
        <?php endwhile; ?>
    </ul>
</body>

</html>
<?php
$db->close();
?>